Dim aComponentCollection, oneComponent, oneInstallshieldProject, TheFiles, i
Dim oneExcelApp, oneExcelBook, oneExcelSheet, oneExcelRange, columnRange
Dim V_MAJOR, V_MINOR, V_BUILD, CurrentFolder
Dim TheInstallshieldProject, TheExcelSheet 

' Get path to script files
TheScriptFile = WScript.ScriptFullName
set oneFileSystemObject = CreateObject("Scripting.FileSystemObject")
Set oneFile = oneFileSystemObject.GetFile(TheScriptFile)
CurrentFolder = oneFile.ParentFolder

' Version numbers to use for Excel sheet
V_MAJOR = Inputbox("Type in Major version", "Excel manifest")
V_MINOR = Inputbox("Type in Minor version", "Excel manifest")
V_BUILD = Inputbox("Type in Build number", "Excel manifest")

' Basic validation of version numbers
if V_MAJOR = "" OR V_MINOR = "" OR V_BUILD = "" then
    Msgbox "Invalid version number entered"
  else
    DoManifest
end if

Sub DoManifest

    On Error Resume Next

	TheInstallshieldProject = CurrentFolder + "\Manifest_Sample.ism"
	TheExcelSheet = CurrentFolder + "\Manifest.xls"
	
	Set oneExcelApp = CreateObject("Excel.Application")
	Set oneExcelBook = oneExcelApp.Workbooks.Open(TheExcelSheet)
	Set oneExcelSheet = oneExcelBook.Worksheets.Add
	   oneExcelSheet.Name =  V_MAJOR & "-" & V_MINOR  & "-" & V_BUILD
	Set oneInstallshieldProject = CreateObject ("ISWiAutomation.ISWiProject")
	   oneInstallshieldProject.OpenProject TheInstallshieldProject
	
	Set oneExcelRange = oneExcelSheet.Cells(1,1)
	   oneExcelRange.Value = "Component"
	   oneExcelRange.Font.Bold = True
	Set oneExcelRange = oneExcelSheet.Cells(1,2)
	   oneExcelRange.Value = "Files                                              "
	   oneExcelRange.Font.Bold = True
	Set oneExcelRange = oneExcelSheet.Cells(1,3)
	   oneExcelRange.Value = "Destination"
	   oneExcelRange.Font.Bold = True
	Set oneExcelRange = oneExcelSheet.Cells(1,4)
	   oneExcelRange.Value = "GUID"
	   oneExcelRange.Font.Bold = True
	
	Set aComponentCollection = oneInstallshieldProject.ISWiComponents
	i = 1
	
	For Each oneComponent In aComponentCollection
	   ' Count lines to set correct range
	   i = i + 1
	   Set oneExcelRange = oneExcelSheet.Cells(i,1)
	   oneExcelRange.Value = CStr(oneComponent.Name)
	   Set oneExcelRange = oneExcelSheet.Cells(i,2)
	
	   Set oneFileCollection = oneComponent.ISWiFiles
	   For Each oneFile In oneFileCollection
	      TheFiles = TheFiles + oneFile.Name + vbLf
	   Next
	
	   oneExcelRange.Value = TheFiles
	
	   TheFiles = ""
	
	   Set oneExcelRange = oneExcelSheet.Cells(i,3)
	   oneExcelRange.Value = CStr(oneComponent.Destination)

	   Set oneExcelRange = oneExcelSheet.Cells(i,4)
	   oneExcelRange.Value = CStr(oneComponent.GUID)

	Next
	
	oneExcelApp.Cells.EntireColumn.AutoFit
	
	oneInstallshieldProject.CloseProject
	Set oneInstallshieldProject = Nothing
	
	oneExcelBook.Save
	oneExcelApp.Quit
	Set oneExcelApp = Nothing

        ' Check for errors...
        If Err.Number <> 0 then
            MsgBox "Error occurred: " + CStr(Err.Number)
            Err.Clear
	    Set oneExcelApp = Nothing
           Else
            MsgBox "Manifest generation completed. Open Excel file to see result"
        End if

End Sub